load data
N=length(y);
deltat=0.002;
% state noise (tuning parameter)
alpha=1e-3;
%create matrices A, C, V, W

Ac=[0 1 0; 0 0 1; 0 0 0 ];
A=expm(Ac*deltat)
C=[1 0 0 ]
V=4
W=diag([1e-8,1e-8,alpha])

%start the KF
xest=zeros(3,1)
Pest=1000*eye(3)

% for recording the estimation history

xSERIES=zeros(3,N);
sigmaSERIES=zeros(3,N);

xSERIES(:,1)=xest;
sigmaSERIES(:,1)= sqrt(diag(Pest));

% start loop

for k=2:N
    
   % prediction step
    xpred=A*xest;
    Ppred=A*Pest*A' + W;
    
    % innovation update
    Pest=inv(inv(Ppred) + C'*inv(V)*C      );
    xest=xpred + Pest*C'*inv(V)*(y(k) - C* xpred);
    
    %record estimate
    xSERIES(:,k)=xest;
    sigmaSERIES(:,k)= sqrt(diag(Pest));
    
end    
    
%plot results

times=deltat*[0:N-1]';

figure(1)
plot(times, y, 'red', times, xSERIES(1,:), 'blue')

figure(2)
subplot(3,1,1)
plot(times, y, 'red', times, xSERIES(1,:), 'blue',times, xSERIES(1,:)+sigmaSERIES(1,:), ...
    'green',times, xSERIES(1,:)-sigmaSERIES(1,:), 'green')

subplot(3,1,2)
plot(times, xSERIES(2,:), 'blue',times, xSERIES(2,:)+sigmaSERIES(2,:), ...
    'green',times, xSERIES(2,:)-sigmaSERIES(2,:), 'green')

subplot(3,1,3)
plot(times, xSERIES(3,:), 'blue',times, xSERIES(3,:)+sigmaSERIES(3,:), ...
    'green',times, xSERIES(3,:)-sigmaSERIES(3,:), 'green')

    